var ger01902_arvoreproduto_controller = function(ScreenService, templateManager, General, metaDataFactory) {
    
    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
    var nivAnteOnCreation;
    
    this.calcMask = function(nvproduto) {
        var mask = getLocalVar('GER_CDPICTPROD');
        mask = mask.split('.');
        mask = mask.slice(0, parseInt(nvproduto));
        return mask.join('.');
    };

    this.cancelEditOrAdd = function(args) {
        var widget = args.owner.widget;
        if (widget.currentRow.__is_new) {
            widget.dataSource.data.pop();
            ScreenService.closeSwipe();
            widget.list();
        } else {
            General.backOrCancel(args);
        }
        this.backToDefaultMask();
    };
    
    this.backToDefaultMask = function() {
        var widget = templateManager.container.getWidget('arvoreProdutoGrid');
        var arvprodField = widget.getField("CDARVPROD");
        
        arvprodField.mask.params.mask = getLocalVar('GER_CDPICTPROD');
        //var newField = metaDataFactory.fieldFactory(arvprodField, widget);
        //widget.fields.splice(0, 1, newField);
    };

    this.deleteProduct = function(widget) {
        let parentOnDataset = false;
        var row = Util.clone(widget.currentRow, ignoredKeys);
        
        if(widget.currentRow._parent)
            parentOnDataset = widget.dataSource.data.filter(row => row.CDARVPROD == widget.currentRow._parent.CDARVPROD)[0];
        
        
        General.callRestEngine('cadEst_produto#/produto_para_arvore/remove', "Row", row).then(function() {
            ScreenService.closeSwipe().then(function() {
                widget.list();
                if(parentOnDataset){
                    parentOnDataset._childCount -= 1;
                    if(parentOnDataset._childCount <= 0){
                        parentOnDataset._hasChild = false;
                        parentOnDataset._opened = false;
                    }
                }
                widget.dataSource.data = widget.dataSource.data.filter(data => {
                    return data != widget.currentRow;
                });
            }); 
        }.bind(this), this.errorRequest); 
    };

    this.errorRequest = function(error) {
       if (error.data.error) {
            if(error.data.error.indexOf("FKCMP00123PRODUTO")>0){
                ScreenService.showMessage("Exclusão não permitida. Nível relacionado a Periodicidade de Entrega na Tela Dados de Produto da Unidade.");
            }
            else{
                ScreenService.showMessage(error.data.error);
            }
        } else {
            ScreenService.showMessage(error);
        }
        ScreenService.hideLoader();
    };

    this.newTree = function(widget) {
        ScreenService.showLoader();
        widget.prodnivante = Util.clone(widget.currentRow, ignoredKeys);
        nivAnteOnCreation = widget.dataSource.data.filter(row => row.CDARVPROD == widget.prodnivante.CDARVPROD)[0];
        var row = {
            'PARENTCDPRODUTO': widget.prodnivante.CDARVPROD || null,
            'PARENTNVPRODUTO': widget.prodnivante.CDNVPRODUTO || null
        };
        General.callRestEngine('cadEst_produto#/sugestedArvprod', 'Row', row).then(function(request) {
            var arvprodField = templateManager.container.getWidget('arvoreProdutoGrid').getField("CDARVPROD");
            var sugested = request.dataset.sugestedArvprod[0];
            
            var parentMask = (parseInt(widget.prodnivante.CDNVPRODUTO || 0) + 1);
            var mask = this.calcMask(parentMask);
            arvprodField.mask.params.mask = mask;
            widget.newRow();
            
            widget.currentRow.CDNVPRODUTO = (parseInt(widget.prodnivante.CDNVPRODUTO || 0) + 1);
            widget.currentRow.CDPRODNIVANTE = widget.prodnivante.CDPRODUTO || null;
            widget.currentRow.CDARVPRODNIVANTE = widget.prodnivante.CDARVPROD || null;
            widget.currentRow.CDARVPROD = sugested.CDDARVPROD;
            //var newField = metaDataFactory.fieldFactory(arvprodField, widget);
            //widget.fields.splice(0, 1, newField);
            
            ScreenService.hideLoader();
        }.bind(this), this.errorRequest);
        
    };

    this.newTreeLevelOne = function(widget) {
        widget.currentRow = {};
        this.newTree(widget);
    };

    this.openSwipe = function(widget) {
        ScreenService.openSwipe(widget).then(function() {
            this.rulesOpenSwipe(widget);
        }.bind(this));
    };

    this.penultimateLevel = function(level) {
        var maxLevel = General.getLevelByMask('GER_CDPICTPROD', 1).length;
        if ((maxLevel -1) > level) {
            return true;
        } else {
            return false;
        }
    };
    
    this.rulesOpenSwipe = function(widget, afterSave = false) {
        //var arvprodField = templateManager.container.getWidget('arvoreProdutoGrid').getField("CDARVPROD");
        
        if (widget.mode != 'edit' && !widget.currentRow.__is_new) {
            // widget.view();
            if (widget.currentRow._hasChild || this.penultimateLevel(widget.currentRow.CDNVPRODUTO)) {
                widget.getAction('adicionar').isVisible = true;
            } else {
                widget.getAction('adicionar').isVisible = false;
            }

            if (widget.currentRow._hasChild) {
                widget.getAction('excluir').isVisible = false;
            } else {
                widget.getAction('excluir').isVisible = true;
            }
        }
        if(afterSave){
            if (widget.currentRow._hasChild || this.penultimateLevel(widget.currentRow.CDNVPRODUTO)) {
                widget.getAction('adicionar').isVisible = true;
            } else {
                widget.getAction('adicionar').isVisible = false;
            }

            if (widget.currentRow._hasChild) {
                widget.getAction('excluir').isVisible = false;
            } else {
                widget.getAction('excluir').isVisible = true;
            }
        }
        //var mask = this.calcMask(widget.currentRow.CDNVPRODUTO || 1);
        // arvprodField.mask.params.mask = mask;
        //var newField = metaDataFactory.fieldFactory(arvprodField, widget);
        //widget.fields.splice(0, 1, newField);
    };

    this.save = function(widget) {
        var row = Util.clone(widget.currentRow, ignoredKeys);
        row.CDARVPROD = valueDesmasked(row.CDARVPROD.toUpperCase());
        
        if (widget.isValid()) {
            General.callRestEngine('cadEst_produto#/produto_para_arvore/save', "Row", row).then(function(success) {
				widget.activate();
				this.rulesOpenSwipe(widget, true);
				if (widget.currentRow.__is_new) {
                    let retCdproduto = success.dataset.columnsToReturn[0].CDPRODUTO;
                    widget.currentRow.CDPRODUTO = retCdproduto;
				    widget.currentRow.__is_new = false;
				    widget.getField('CDARVPROD').mask.params.mask= "@getLocalVar('GER_CDPICTPROD')@";
					widget.view();  
					if(nivAnteOnCreation || row.CDNVPRODUTO > 1){
    					if(!nivAnteOnCreation? true : !nivAnteOnCreation._opened){
        					widget.dataSource.data.pop(); 
    					} 
    					if(nivAnteOnCreation){
                            nivAnteOnCreation._hasChild = true;
                            nivAnteOnCreation._childCount += 1;
    					} 
					}
					widget.getAction('excluir').isVisible = true;
				} else {
					widget.view();
				}
			}.bind(this), this.errorRequest);
        }
    };
    
    this.newGroupOperRules = function(widgetGroupOper){
        let widgetProductTree = widgetGroupOper.getParent();
        widgetGroupOper.currentRow.CDPRODUTO = widgetProductTree.currentRow.CDPRODUTO;
    };
    
    this.saveMaskAction = function(widget){
        let gridArvore = widget.getParent();
        let fieldMask = widget.getField('CDPICTPROD'); 
        fieldMask.value(fieldMask.value().toLowerCase());
        widget.dataSource.name = 'cadEst#/paramgeralMask';
        General.saveCrud(widget).then(success => {
            widget.dataSource.name = 'cadEst#/crud/paramgeral';
            ScreenService.closePopup();
            ScreenService.closeSwipe();
            gridArvore.activate();
        });
    };
    
    this.preventUnwantedKeys = function(args){
        let arrAllowedKeys = ['9','a','A','.'];
        if(!arrAllowedKeys.includes(args.e.key)){
            args.e.preventDefault();
        }
    };
    
    this.setCurrentRowWithData = function (widget){
        widget.currentRow = widget.dataSource.data[0];
    };
    
    this.changeMaskVisibility = function(widget){
        let maskWidget = widget.container.getWidget('maskPopup');
        let fieldMask  = maskWidget.getField('CDPICTPROD');
        
        fieldMask.readOnlyOnEdit = widget.dataSource.data.length == 0?  false : true;
        fieldMask.readOnly       = widget.dataSource.data.length == 0?  false : true;
    };
    
    this.codArvToUpperCase = function(widget){
        let fieldCodArv = widget.getField('CDARVPROD');
        fieldCodArv.value(valueDesmasked(widget.currentRow.CDARVPROD.toUpperCase()));
    };
    
    var valueDesmasked = function(value){
        return value.split('.').join('');
    };
    
    this.changeDataSourceBeforeReport = function(widget){
      console.log(widget);  
    };
    
};

Configuration(function (ContextRegister, eventEngine) {
	ContextRegister.register('ger01902_arvoreproduto_controller', ger01902_arvoreproduto_controller);
});